/*
 * gaintool_ui.c - User interface object initialization functions.
 */
#ifndef lint
static  char sccsid[] = "@(#)gaintool_ui.c 1.1 90/09/21 Copyr 1989 Sun Micro";
#endif

/*
 * Copyright (c) 1989 by Sun Microsystems, Inc.
 */



#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/icon_load.h>
#include <xview/panel.h>
#include <xview/scrollbar.h>
#include <xview/svrimage.h>
#include <xview/termsw.h>
#include <xview/text.h>
#include <xview/tty.h>
#include <xview/xv_xrect.h>
#include "gaintool_ui.h"

/*
 * Initialize an instance of object `BaseFrame'.
 */
gaintool_BaseFrame_objects *
gaintool_BaseFrame_objects_initialize(ip, owner)
	gaintool_BaseFrame_objects	*ip;
	Xv_opaque	owner;
{
	if (!ip && !(ip = (gaintool_BaseFrame_objects *) calloc(1, sizeof (gaintool_BaseFrame_objects))))
		return (gaintool_BaseFrame_objects *) NULL;
	if (!ip->BaseFrame)
		ip->BaseFrame = gaintool_BaseFrame_BaseFrame_create(ip, owner);
	if (!ip->GainPanel)
		ip->GainPanel = gaintool_BaseFrame_GainPanel_create(ip, ip->BaseFrame);
	if (!ip->PlaySlider)
		ip->PlaySlider = gaintool_BaseFrame_PlaySlider_create(ip, ip->GainPanel);
	if (!ip->RecordSlider)
		ip->RecordSlider = gaintool_BaseFrame_RecordSlider_create(ip, ip->GainPanel);
	if (!ip->MonitorSlider)
		ip->MonitorSlider = gaintool_BaseFrame_MonitorSlider_create(ip, ip->GainPanel);
	if (!ip->OutputSwitch)
		ip->OutputSwitch = gaintool_BaseFrame_OutputSwitch_create(ip, ip->GainPanel);
	if (!ip->Pause_button)
		ip->Pause_button = gaintool_BaseFrame_Pause_button_create(ip, ip->GainPanel);
	return ip;
}

/*
 * Create object `BaseFrame' in the specified instance.

 */
Xv_opaque
gaintool_BaseFrame_BaseFrame_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	Xv_opaque		BaseFrame_image;
	static unsigned short	BaseFrame_bits[] = {
#include "gaintool.icon"
	};
	
	BaseFrame_image = xv_create(XV_NULL, SERVER_IMAGE,
		SERVER_IMAGE_BITS, BaseFrame_bits,
		SERVER_IMAGE_DEPTH, 1,
		XV_WIDTH, 64,
		XV_HEIGHT, 64,
		NULL);
	obj = xv_create(owner, FRAME,
		XV_KEY_DATA, INSTANCE, ip,
		XV_WIDTH, 290,
		XV_HEIGHT, 89,
		XV_LABEL, "Audio Control Panel",
		FRAME_CLOSED, FALSE,
		FRAME_SHOW_FOOTER, FALSE,
		FRAME_SHOW_RESIZE_CORNER, TRUE,
		FRAME_ICON, xv_create(XV_NULL, ICON,
			ICON_IMAGE, BaseFrame_image,
			NULL),
		NULL);
	return obj;
}

/*
 * Create object `GainPanel' in the specified instance.

 */
Xv_opaque
gaintool_BaseFrame_GainPanel_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	extern Notify_value	main_event_proc();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 0,
		XV_Y, 0,
		XV_WIDTH, WIN_EXTEND_TO_EDGE,
		XV_HEIGHT, WIN_EXTEND_TO_EDGE,
		WIN_BORDER, FALSE,
		NULL);
	xv_set(obj, WIN_CONSUME_EVENTS,
		WIN_LEFT_KEYS,
		NULL, NULL);
	notify_interpose_event_func(obj,
		(Notify_func) main_event_proc, NOTIFY_SAFE);
	return obj;
}

/*
 * Create object `PlaySlider' in the specified instance.

 */
Xv_opaque
gaintool_BaseFrame_PlaySlider_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	extern int		play_volume_proc();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_SLIDER,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 56,
		XV_Y, 4,
		XV_WIDTH, 236,
		XV_HEIGHT, 15,
		PANEL_VALUE_X, 132,
		PANEL_VALUE_Y, 4,
		PANEL_SLIDER_WIDTH, 100,
		PANEL_LABEL_STRING, "Play Gain:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_DIRECTION, PANEL_HORIZONTAL,
		PANEL_SLIDER_END_BOXES, FALSE,
		PANEL_SHOW_RANGE, FALSE,
		PANEL_SHOW_VALUE, TRUE,
		PANEL_MIN_VALUE, 0,
		PANEL_MAX_VALUE, 100,
		PANEL_TICKS, 0,
		PANEL_NOTIFY_PROC, play_volume_proc,
		NULL);
	return obj;
}

/*
 * Create object `RecordSlider' in the specified instance.

 */
Xv_opaque
gaintool_BaseFrame_RecordSlider_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	extern int		record_volume_proc();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_SLIDER,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 39,
		XV_Y, 23,
		XV_WIDTH, 253,
		XV_HEIGHT, 15,
		PANEL_VALUE_X, 132,
		PANEL_VALUE_Y, 23,
		PANEL_SLIDER_WIDTH, 100,
		PANEL_LABEL_STRING, "Record Gain:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_DIRECTION, PANEL_HORIZONTAL,
		PANEL_SLIDER_END_BOXES, FALSE,
		PANEL_SHOW_RANGE, FALSE,
		PANEL_SHOW_VALUE, TRUE,
		PANEL_MIN_VALUE, 0,
		PANEL_MAX_VALUE, 100,
		PANEL_TICKS, 0,
		PANEL_NOTIFY_PROC, record_volume_proc,
		NULL);
	return obj;
}

/*
 * Create object `MonitorSlider' in the specified instance.

 */
Xv_opaque
gaintool_BaseFrame_MonitorSlider_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	extern int		monitor_volume_proc();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_SLIDER,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 11,
		XV_Y, 43,
		XV_WIDTH, 281,
		XV_HEIGHT, 15,
		PANEL_VALUE_X, 132,
		PANEL_VALUE_Y, 43,
		PANEL_SLIDER_WIDTH, 100,
		PANEL_LABEL_STRING, "Monitor Volume:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_DIRECTION, PANEL_HORIZONTAL,
		PANEL_SLIDER_END_BOXES, FALSE,
		PANEL_SHOW_RANGE, FALSE,
		PANEL_SHOW_VALUE, TRUE,
		PANEL_MIN_VALUE, 0,
		PANEL_MAX_VALUE, 100,
		PANEL_TICKS, 0,
		PANEL_NOTIFY_PROC, monitor_volume_proc,
		NULL);
	return obj;
}

/*
 * Create object `OutputSwitch' in the specified instance.

 */
Xv_opaque
gaintool_BaseFrame_OutputSwitch_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	extern int		control_output_proc();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_CHOICE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 16,
		XV_Y, 68,
		XV_WIDTH, 143,
		XV_HEIGHT, 23,
		PANEL_VALUE_X, 76,
		PANEL_VALUE_Y, 68,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_CHOICE_NROWS, 1,
		PANEL_LABEL_STRING, "Output:",
		PANEL_NOTIFY_PROC, control_output_proc,
		PANEL_CHOICE_STRINGS,
			"Spkr",
			"Jack",
			0,
		NULL);
	return obj;
}

/*
 * Create object `Pause_button' in the specified instance.

 */
Xv_opaque
gaintool_BaseFrame_Pause_button_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	extern void		pause_proc();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 184,
		XV_Y, 68,
		XV_WIDTH, 84,
		XV_HEIGHT, 20,
		PANEL_LABEL_STRING, "Pause Play",
		PANEL_NOTIFY_PROC, pause_proc,
		NULL);
	return obj;
}

/*
 * Initialize an instance of object `PropSheet'.
 */
gaintool_PropSheet_objects *
gaintool_PropSheet_objects_initialize(ip, owner)
	gaintool_PropSheet_objects	*ip;
	Xv_opaque	owner;
{
	if (!ip && !(ip = (gaintool_PropSheet_objects *) calloc(1, sizeof (gaintool_PropSheet_objects))))
		return (gaintool_PropSheet_objects *) NULL;
	if (!ip->PropSheet)
		ip->PropSheet = gaintool_PropSheet_PropSheet_create(ip, owner);
	if (!ip->PlayPropsPanel)
		ip->PlayPropsPanel = gaintool_PropSheet_PlayPropsPanel_create(ip, ip->PropSheet);
	if (!ip->Ppanel_label)
		ip->Ppanel_label = gaintool_PropSheet_Ppanel_label_create(ip, ip->PlayPropsPanel);
	if (!ip->Popen_flag)
		ip->Popen_flag = gaintool_PropSheet_Popen_flag_create(ip, ip->PlayPropsPanel);
	if (!ip->Ppaused_flag)
		ip->Ppaused_flag = gaintool_PropSheet_Ppaused_flag_create(ip, ip->PlayPropsPanel);
	if (!ip->Pactive_flag)
		ip->Pactive_flag = gaintool_PropSheet_Pactive_flag_create(ip, ip->PlayPropsPanel);
	if (!ip->Puf_flag)
		ip->Puf_flag = gaintool_PropSheet_Puf_flag_create(ip, ip->PlayPropsPanel);
	if (!ip->Pow_flag)
		ip->Pow_flag = gaintool_PropSheet_Pow_flag_create(ip, ip->PlayPropsPanel);
	if (!ip->Peof_label)
		ip->Peof_label = gaintool_PropSheet_Peof_label_create(ip, ip->PlayPropsPanel);
	if (!ip->Peof_value)
		ip->Peof_value = gaintool_PropSheet_Peof_value_create(ip, ip->PlayPropsPanel);
	if (!ip->Psam_label)
		ip->Psam_label = gaintool_PropSheet_Psam_label_create(ip, ip->PlayPropsPanel);
	if (!ip->Psam_value)
		ip->Psam_value = gaintool_PropSheet_Psam_value_create(ip, ip->PlayPropsPanel);
	if (!ip->Psamr_label)
		ip->Psamr_label = gaintool_PropSheet_Psamr_label_create(ip, ip->PlayPropsPanel);
	if (!ip->Psamr_value)
		ip->Psamr_value = gaintool_PropSheet_Psamr_value_create(ip, ip->PlayPropsPanel);
	if (!ip->Pchan_label)
		ip->Pchan_label = gaintool_PropSheet_Pchan_label_create(ip, ip->PlayPropsPanel);
	if (!ip->Pchan_value)
		ip->Pchan_value = gaintool_PropSheet_Pchan_value_create(ip, ip->PlayPropsPanel);
	if (!ip->Pprec_label)
		ip->Pprec_label = gaintool_PropSheet_Pprec_label_create(ip, ip->PlayPropsPanel);
	if (!ip->Pprec_value)
		ip->Pprec_value = gaintool_PropSheet_Pprec_value_create(ip, ip->PlayPropsPanel);
	if (!ip->Pencod_label)
		ip->Pencod_label = gaintool_PropSheet_Pencod_label_create(ip, ip->PlayPropsPanel);
	if (!ip->Pencode_value)
		ip->Pencode_value = gaintool_PropSheet_Pencode_value_create(ip, ip->PlayPropsPanel);
	if (!ip->RecPropsPanel)
		ip->RecPropsPanel = gaintool_PropSheet_RecPropsPanel_create(ip, ip->PropSheet);
	if (!ip->Rpanel_label)
		ip->Rpanel_label = gaintool_PropSheet_Rpanel_label_create(ip, ip->RecPropsPanel);
	if (!ip->Ropen_flag)
		ip->Ropen_flag = gaintool_PropSheet_Ropen_flag_create(ip, ip->RecPropsPanel);
	if (!ip->Rpaused_flag)
		ip->Rpaused_flag = gaintool_PropSheet_Rpaused_flag_create(ip, ip->RecPropsPanel);
	if (!ip->Ractive_flag)
		ip->Ractive_flag = gaintool_PropSheet_Ractive_flag_create(ip, ip->RecPropsPanel);
	if (!ip->Rof_flag)
		ip->Rof_flag = gaintool_PropSheet_Rof_flag_create(ip, ip->RecPropsPanel);
	if (!ip->Row_flag)
		ip->Row_flag = gaintool_PropSheet_Row_flag_create(ip, ip->RecPropsPanel);
	if (!ip->Rsam_label)
		ip->Rsam_label = gaintool_PropSheet_Rsam_label_create(ip, ip->RecPropsPanel);
	if (!ip->Rsam_value)
		ip->Rsam_value = gaintool_PropSheet_Rsam_value_create(ip, ip->RecPropsPanel);
	if (!ip->Rsamr_label)
		ip->Rsamr_label = gaintool_PropSheet_Rsamr_label_create(ip, ip->RecPropsPanel);
	if (!ip->Rsamr_value)
		ip->Rsamr_value = gaintool_PropSheet_Rsamr_value_create(ip, ip->RecPropsPanel);
	if (!ip->Rchan_label)
		ip->Rchan_label = gaintool_PropSheet_Rchan_label_create(ip, ip->RecPropsPanel);
	if (!ip->Rchan_value)
		ip->Rchan_value = gaintool_PropSheet_Rchan_value_create(ip, ip->RecPropsPanel);
	if (!ip->Rprec_label)
		ip->Rprec_label = gaintool_PropSheet_Rprec_label_create(ip, ip->RecPropsPanel);
	if (!ip->Rprec_value)
		ip->Rprec_value = gaintool_PropSheet_Rprec_value_create(ip, ip->RecPropsPanel);
	if (!ip->Rencod_label)
		ip->Rencod_label = gaintool_PropSheet_Rencod_label_create(ip, ip->RecPropsPanel);
	if (!ip->Rencode_value)
		ip->Rencode_value = gaintool_PropSheet_Rencode_value_create(ip, ip->RecPropsPanel);
	return ip;
}

/*
 * Create object `PropSheet' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_PropSheet_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	extern void	props_done_proc();
	extern Notify_value	status_loc();
	Xv_opaque	obj;
	
	obj = xv_create(owner, FRAME_CMD,
		XV_KEY_DATA, INSTANCE, ip,
		XV_WIDTH, 365,
		XV_HEIGHT, 280,
		XV_LABEL, "Audio Device Status",
		XV_SHOW, FALSE,
		FRAME_SHOW_FOOTER, FALSE,
		FRAME_SHOW_RESIZE_CORNER, TRUE,
		FRAME_CMD_PUSHPIN_IN, TRUE,
		FRAME_DONE_PROC, props_done_proc,
		NULL);
	xv_set(obj, WIN_CONSUME_EVENTS,
		LOC_WINENTER,
		LOC_WINEXIT,
		NULL, NULL);
	notify_interpose_event_func(obj,
		(Notify_func) status_loc, NOTIFY_SAFE);
	xv_set(xv_get(obj, FRAME_CMD_PANEL), WIN_SHOW, FALSE, NULL);
	return obj;
}

/*
 * Create object `PlayPropsPanel' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_PlayPropsPanel_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 0,
		XV_Y, 0,
		XV_WIDTH, 183,
		XV_HEIGHT, WIN_EXTEND_TO_EDGE,
		WIN_BORDER, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `Ppanel_label' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Ppanel_label_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 47,
		XV_Y, 9,
		XV_WIDTH, 77,
		XV_HEIGHT, 13,
		PANEL_LABEL_STRING, "Play Status",
		PANEL_LABEL_BOLD, TRUE,
		NULL);
	return obj;
}

/*
 * Create object `Popen_flag' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Popen_flag_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 3,
		XV_Y, 34,
		XV_WIDTH, 76,
		XV_HEIGHT, 23,
		PANEL_VALUE_X, 12,
		PANEL_VALUE_Y, 34,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_CHOICE_NROWS, 1,
		PANEL_CHOICE_STRING, 0, "Open",
		NULL);
	return obj;
}

/*
 * Create object `Ppaused_flag' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Ppaused_flag_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 3,
		XV_Y, 54,
		XV_WIDTH, 87,
		XV_HEIGHT, 23,
		PANEL_VALUE_X, 12,
		PANEL_VALUE_Y, 54,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_CHOICE_NROWS, 1,
		PANEL_CHOICE_STRING, 0, "Paused",
		NULL);
	return obj;
}

/*
 * Create object `Pactive_flag' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Pactive_flag_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 3,
		XV_Y, 82,
		XV_WIDTH, 80,
		XV_HEIGHT, 23,
		PANEL_VALUE_X, 12,
		PANEL_VALUE_Y, 82,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_CHOICE_NROWS, 1,
		PANEL_CHOICE_STRING, 0, "Active",
		NULL);
	return obj;
}

/*
 * Create object `Puf_flag' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Puf_flag_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 3,
		XV_Y, 102,
		XV_WIDTH, 107,
		XV_HEIGHT, 23,
		PANEL_VALUE_X, 12,
		PANEL_VALUE_Y, 102,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_CHOICE_NROWS, 1,
		PANEL_CHOICE_STRING, 0, "Underflow",
		NULL);
	return obj;
}

/*
 * Create object `Pow_flag' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Pow_flag_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 3,
		XV_Y, 122,
		XV_WIDTH, 130,
		XV_HEIGHT, 23,
		PANEL_VALUE_X, 12,
		PANEL_VALUE_Y, 122,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_CHOICE_NROWS, 1,
		PANEL_CHOICE_STRING, 0, "Open-Waiting",
		NULL);
	return obj;
}

/*
 * Create object `Peof_label' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Peof_label_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 12,
		XV_Y, 152,
		XV_WIDTH, 68,
		XV_HEIGHT, 13,
		PANEL_LABEL_STRING, "EOF Count:",
		PANEL_LABEL_BOLD, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `Peof_value' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Peof_value_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 123,
		XV_Y, 152,
		XV_WIDTH, 8,
		XV_HEIGHT, 13,
		PANEL_LABEL_STRING, "0",
		PANEL_LABEL_BOLD, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `Psam_label' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Psam_label_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 12,
		XV_Y, 172,
		XV_WIDTH, 54,
		XV_HEIGHT, 13,
		PANEL_LABEL_STRING, "Samples:",
		PANEL_LABEL_BOLD, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `Psam_value' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Psam_value_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 94,
		XV_Y, 172,
		XV_WIDTH, 36,
		XV_HEIGHT, 13,
		PANEL_LABEL_STRING, "       0",
		PANEL_LABEL_BOLD, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `Psamr_label' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Psamr_label_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 12,
		XV_Y, 202,
		XV_WIDTH, 79,
		XV_HEIGHT, 13,
		PANEL_LABEL_STRING, "Sample Rate:",
		PANEL_LABEL_BOLD, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `Psamr_value' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Psamr_value_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 120,
		XV_Y, 202,
		XV_WIDTH, 32,
		XV_HEIGHT, 13,
		PANEL_LABEL_STRING, "8000",
		PANEL_LABEL_BOLD, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `Pchan_label' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Pchan_label_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 12,
		XV_Y, 222,
		XV_WIDTH, 60,
		XV_HEIGHT, 13,
		PANEL_LABEL_STRING, "Channels:",
		PANEL_LABEL_BOLD, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `Pchan_value' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Pchan_value_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 120,
		XV_Y, 222,
		XV_WIDTH, 8,
		XV_HEIGHT, 13,
		PANEL_LABEL_STRING, "1",
		PANEL_LABEL_BOLD, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `Pprec_label' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Pprec_label_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 12,
		XV_Y, 242,
		XV_WIDTH, 58,
		XV_HEIGHT, 13,
		PANEL_LABEL_STRING, "Precision:",
		PANEL_LABEL_BOLD, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `Pprec_value' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Pprec_value_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 121,
		XV_Y, 242,
		XV_WIDTH, 8,
		XV_HEIGHT, 13,
		PANEL_LABEL_STRING, "8",
		PANEL_LABEL_BOLD, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `Pencod_label' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Pencod_label_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 12,
		XV_Y, 262,
		XV_WIDTH, 58,
		XV_HEIGHT, 13,
		PANEL_LABEL_STRING, "Encoding:",
		PANEL_LABEL_BOLD, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `Pencode_value' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Pencode_value_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 121,
		XV_Y, 262,
		XV_WIDTH, 38,
		XV_HEIGHT, 13,
		PANEL_LABEL_STRING, "u-law",
		PANEL_LABEL_BOLD, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `RecPropsPanel' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_RecPropsPanel_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 184,
		XV_Y, 0,
		XV_WIDTH, WIN_EXTEND_TO_EDGE,
		XV_HEIGHT, WIN_EXTEND_TO_EDGE,
		WIN_BORDER, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `Rpanel_label' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Rpanel_label_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 64,
		XV_Y, 16,
		XV_WIDTH, 94,
		XV_HEIGHT, 13,
		PANEL_LABEL_STRING, "Record Status",
		PANEL_LABEL_BOLD, TRUE,
		NULL);
	return obj;
}

/*
 * Create object `Ropen_flag' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Ropen_flag_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 3,
		XV_Y, 34,
		XV_WIDTH, 76,
		XV_HEIGHT, 23,
		PANEL_VALUE_X, 12,
		PANEL_VALUE_Y, 34,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_CHOICE_NROWS, 1,
		PANEL_CHOICE_STRING, 0, "Open",
		NULL);
	return obj;
}

/*
 * Create object `Rpaused_flag' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Rpaused_flag_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 3,
		XV_Y, 54,
		XV_WIDTH, 87,
		XV_HEIGHT, 23,
		PANEL_VALUE_X, 12,
		PANEL_VALUE_Y, 54,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_CHOICE_NROWS, 1,
		PANEL_CHOICE_STRING, 0, "Paused",
		NULL);
	return obj;
}

/*
 * Create object `Ractive_flag' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Ractive_flag_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 3,
		XV_Y, 82,
		XV_WIDTH, 80,
		XV_HEIGHT, 23,
		PANEL_VALUE_X, 12,
		PANEL_VALUE_Y, 82,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_CHOICE_NROWS, 1,
		PANEL_CHOICE_STRING, 0, "Active",
		NULL);
	return obj;
}

/*
 * Create object `Rof_flag' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Rof_flag_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 3,
		XV_Y, 102,
		XV_WIDTH, 99,
		XV_HEIGHT, 23,
		PANEL_VALUE_X, 12,
		PANEL_VALUE_Y, 102,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_CHOICE_NROWS, 1,
		PANEL_CHOICE_STRING, 0, "Overflow",
		NULL);
	return obj;
}

/*
 * Create object `Row_flag' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Row_flag_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 3,
		XV_Y, 122,
		XV_WIDTH, 130,
		XV_HEIGHT, 23,
		PANEL_VALUE_X, 12,
		PANEL_VALUE_Y, 122,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_CHOICE_NROWS, 1,
		PANEL_CHOICE_STRING, 0, "Open-Waiting",
		NULL);
	return obj;
}

/*
 * Create object `Rsam_label' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Rsam_label_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 8,
		XV_Y, 168,
		XV_WIDTH, 54,
		XV_HEIGHT, 13,
		PANEL_LABEL_STRING, "Samples:",
		PANEL_LABEL_BOLD, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `Rsam_value' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Rsam_value_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 91,
		XV_Y, 169,
		XV_WIDTH, 36,
		XV_HEIGHT, 13,
		PANEL_LABEL_STRING, "       0",
		PANEL_LABEL_BOLD, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `Rsamr_label' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Rsamr_label_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 12,
		XV_Y, 202,
		XV_WIDTH, 79,
		XV_HEIGHT, 13,
		PANEL_LABEL_STRING, "Sample Rate:",
		PANEL_LABEL_BOLD, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `Rsamr_value' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Rsamr_value_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 119,
		XV_Y, 202,
		XV_WIDTH, 32,
		XV_HEIGHT, 13,
		PANEL_LABEL_STRING, "8000",
		PANEL_LABEL_BOLD, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `Rchan_label' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Rchan_label_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 12,
		XV_Y, 222,
		XV_WIDTH, 60,
		XV_HEIGHT, 13,
		PANEL_LABEL_STRING, "Channels:",
		PANEL_LABEL_BOLD, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `Rchan_value' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Rchan_value_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 120,
		XV_Y, 222,
		XV_WIDTH, 8,
		XV_HEIGHT, 13,
		PANEL_LABEL_STRING, "1",
		PANEL_LABEL_BOLD, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `Rprec_label' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Rprec_label_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 12,
		XV_Y, 242,
		XV_WIDTH, 58,
		XV_HEIGHT, 13,
		PANEL_LABEL_STRING, "Precision:",
		PANEL_LABEL_BOLD, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `Rprec_value' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Rprec_value_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 120,
		XV_Y, 242,
		XV_WIDTH, 8,
		XV_HEIGHT, 13,
		PANEL_LABEL_STRING, "8",
		PANEL_LABEL_BOLD, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `Rencod_label' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Rencod_label_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 12,
		XV_Y, 262,
		XV_WIDTH, 58,
		XV_HEIGHT, 13,
		PANEL_LABEL_STRING, "Encoding:",
		PANEL_LABEL_BOLD, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `Rencode_value' in the specified instance.

 */
Xv_opaque
gaintool_PropSheet_Rencode_value_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 121,
		XV_Y, 262,
		XV_WIDTH, 38,
		XV_HEIGHT, 13,
		PANEL_LABEL_STRING, "u-law",
		PANEL_LABEL_BOLD, FALSE,
		NULL);
	return obj;
}

